#ifndef TESTLINKEDLIST_H
#define TESTLINKEDLIST_H

      
#include <iostream>
#include <string>

// Note 1
#include <cppunit/TestFixture.h>
#include <cppunit/extensions/HelperMacros.h>

extern "C" {
  #include "linkedlist.h"   
}



using namespace std;

class LinkedListTestCase : public CppUnit::TestFixture { // Note 2 
  CPPUNIT_TEST_SUITE(LinkedListTestCase);
  CPPUNIT_TEST(testInit);
  CPPUNIT_TEST(testAddNull);
  CPPUNIT_TEST(testAdd);
  CPPUNIT_TEST(testAddIndex);
  CPPUNIT_TEST(testRemove);
  CPPUNIT_TEST(testGet);
  CPPUNIT_TEST(testClear);
  CPPUNIT_TEST(testSize);
  CPPUNIT_TEST(testIterator);
  CPPUNIT_TEST_SUITE_END();

 private:
  linkedList myList;
  void setupBasicList();

public:
    void setUp();
    void tearDown();

 protected:
  void testInit();
  void testAdd();
  void testAddIndex();
  void testAddNull();
  void testRemove();
  void testGet();
  void testClear();
  void testSize();
  void testIterator();
};
#endif
          
