#include <stdio.h>
#include <string.h>
#include "linkedlist.h"


int main(int argc, char* argv[])
{
  struct linkedList myList;
  int index;

  ll_init(&myList);

  for (index = 1; index < argc; index++)
  {
    ll_add(&myList, argv[index], strlen(argv[index])+1);
    printf("%d\t", ll_size(&myList));
  }

  struct linkedListIterator* iter = ll_getIterator(&myList);
 
  while (ll_hasNext(iter)==true)
  {
    char* data = ll_next(iter);
    printf("%s\n", &data[0]);
  }

  printf("######################################################################\n");

  ll_clear(&myList);


  for (index = 1; index < argc; index++)
  {
    ll_add(&myList, argv[index], strlen(argv[index])+1);
  }
  ll_add(&myList, "Break", 6);

  uint32_t testPoint = ll_size(&myList);

  for (index = 0; index < argc; index++)
  {
    ll_addIndex(&myList, "TEST", 4+1, testPoint);
    ll_addIndex(&myList, argv[index], strlen(argv[index])+1, 0);
  }

  iter = ll_getIterator(&myList);
 
  while (ll_hasNext(iter)==true)
  {
    char* data = ll_next(iter);
    printf("%s\n", &data[0]);
  }

  ll_clear(&myList);

  printf("######################################################################\n");

  ll_add(&myList, "Hello", 6);
  ll_add(&myList, "World", 6);
  ll_add(&myList, "This is", 10);
  ll_add(&myList, "a test.", 10);

  for (index = 3; index >=0; index--)
  {
    char *data = ll_get(&myList, index);
    printf("%s\n", data);
  }  

  ll_clear(&myList);

  printf("######################################################################\n");

  ll_add(&myList, "Hello", 6);
  ll_add(&myList, "World", 6);
  ll_add(&myList, "This is", 10);
  ll_add(&myList, "a test.", 10);

  ll_remove(&myList, 1);

  for (index = 2; index >=0; index--)
  {
    char *data = ll_get(&myList, index);
    printf("%s\n", data);
  }  

  ll_remove(&myList, 2);

  for (index = 1; index >=0; index--)
  {
    char *data = ll_get(&myList, index);
    printf("%s\n", data);
  }  

  ll_remove(&myList, 0);

  for (index = 0; index >=0; index--)
  {
    char *data = ll_get(&myList, index);
    printf("%s\n", data);
  }  

  ll_remove(&myList, 0);

  if (ll_size(&myList)!=0)
    {
      printf("Error: Improper size...");

    }

  printf("######################################################################\n");
  

}
